//+------------------------------------------------------------------+
//|                                           Phase Change Index.mq4 |
//|                                                       Akif TOKUZ |
//|                                             akifusenet@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Akif TOKUZ"
#property link      "akifusenet@gmail.com"

#property indicator_separate_window

#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_level1 0

//---- input parameters
extern int PeriodPCI=35;
//---- buffers
double Momentum[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(1);
   
   SetIndexBuffer(0,Momentum);   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"Momentum");
   SetIndexEmptyValue(0,0.0);
   
   
   IndicatorShortName("PCI-Momentum"+"("+PeriodPCI+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int startIndex;
   int limit,i;
   double momentum;
   int    counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) limit=Bars-counted_bars;
   if (counted_bars==0) 
   {
      limit=Bars-PeriodPCI;
      for (i=Bars-1;i>limit;i--)
      {
         Momentum[i]=0.0;
      }      
   }

   for(i=limit; i>=0; i--)
   {
      Momentum[i]=Close[i]-Close[i+PeriodPCI-1];
   }
         
   return(0);
  }
//+------------------------------------------------------------------+